package cn.com.infosec.crypto.paddings;

import cn.com.infosec.crypto.InvalidCipherTextException;
import java.security.SecureRandom;

public class ISO10126d2Padding implements BlockCipherPadding {
   SecureRandom random;

   public void init(SecureRandom random) {
      if (random != null) {
         this.random = random;
      } else {
         ISO10126d2Padding var10000 = this;
         SecureRandom var2;
         var2 = new SecureRandom.<init>();
         var10000.random = var2;
      }

   }

   public String getPaddingName() {
      return "ISO10126-2";
   }

   public int addPadding(byte[] in, int inOff) {
      byte var3;
      for(var3 = (byte)(in.length - inOff); inOff < in.length - 1; ++inOff) {
         in[inOff] = (byte)this.random.nextInt();
      }

      in[inOff] = var3;
      return var3;
   }

   public int padCount(byte[] in) {
      int var2;
      if ((var2 = in[in.length - 1] & 255) <= in.length) {
         return var2;
      } else {
         throw new InvalidCipherTextException("pad block corrupted");
      }
   }
}
